<?php
add_filter('cron_schedules', 'cron_add_every10m');
function cron_add_every10m($schedules) {
	$schedules['every10m'] = array(
		'interval' => 600,
		'display' => __('Every 10 Minutes')
	);
	return $schedules;
}

if( !wp_next_scheduled('WP_auto_tag_related_old_post' ) ) {
	wp_schedule_event(time() + 30, 'every10m', 'WP_auto_tag_related_old_post');
}

add_action('WP_auto_tag_related_old_post', 'do_WP_auto_tag_related_old_post');
function do_WP_auto_tag_related_old_post() {
	global $wpdb, $WAT_item, $post;

	$post_type = get_post_types();
	unset($post_type['attachment']);
	unset($post_type['revision']);
	unset($post_type['nav_menu_item']);
	$old_count = get_option('WP_auto_tag_related_old_post_count');
	$query = "SELECT COUNT(*) AS num_posts FROM {$wpdb->posts} WHERE `post_type` IN ('" . implode("','", $post_type) . "') AND `post_status` = 'publish'";
	$total_post = $wpdb->get_results($wpdb->prepare($query), ARRAY_A);
	$total_post = $total_post[0]['num_posts'];

	if( $total_post > $old_count ) {
		$query = array(
			'post_type' => $post_type,
			'post_status' => 'publish',
			'posts_per_page' => 10,
			'order' => 'ASC',
			'orderby' => 'ID',
			'offset' => $old_count
		);
		$sand_post = new WP_Query($query);
		while( $sand_post->have_posts() ) {
			$sand_post->the_post();
			$max_id = $post->ID;
			$WAT_item->related_post($post->ID, $post);
			$old_count++;
			sleep(3);
		}
		update_option('WP_auto_tag_related_old_post_count', $old_count);
	} else {
		if( wp_get_schedule('WP_auto_tag_related_old_post') == 'every10m' ) {
			wp_clear_scheduled_hook('WP_auto_tag_related_old_post');
			wp_schedule_event(time() + 30, 'daily', 'WP_auto_tag_related_old_post');
		}
	}
}
?>