<?php
add_action('widgets_init', 'wp_auto_tag_widget_init');
function wp_auto_tag_widget_init() {
	register_widget('WP_auto_tag_Related_Post');
}

class WP_auto_tag_Related_Post extends WP_Widget {
	public function __construct() {
		$widget_ops = array('description' => '顯示與目前頁面相關的文章');
		parent::__construct('wat-related-post', '相關文章', $widget_ops);
	}
	public function widget($args, $instance) {
		extract($args);
		$title = apply_filters('widget_title', empty($instance['title']) ? '相關文章' : $instance['title'], $instance, $this->id_base);
		$count = intval($instance['count']);

		global $wp_query;
		$wp_query->rewind_posts();
		$IDs = array();
		while( $wp_query->have_posts() ) {
			$wp_query->the_post();
			$IDs[] = get_the_ID();
		}
		$wp_query->rewind_posts();

		$url_hash = sprintf('%u', crc32(strtolower(substr(get_bloginfo('wpurl'), 7)))) . strlen(get_bloginfo('wpurl'));
		$IDs = implode(',', $IDs);
		echo <<<END
$before_widget
$before_title $title $after_title
<ul class="wat-related-post"></ul>
$after_widget
<script type="text/javascript">
var _wat_url_hash=$url_hash,_wat_widget_related_ids='$IDs',_wat_widget_count=$count;
</script>
END;
	}
	public function update($new_instance, $old_instance) {
		$instance = $old_instance;
		$instance['title'] = strip_tags($new_instance['title']);
		$instance['count'] = intval($new_instance['count']);
		return $instance;
	}
	public function form($instance) {
		$instance = wp_parse_args((array) $instance, array('title' => '相關文章', 'count' => 10));
		$title = esc_attr($instance['title']);
		$count = intval($instance['count']);
		?>
<p>
	<label for="<?php echo $this->get_field_id('title'); ?>">標題：</label>
	<input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo $title; ?>" />
</p>
<p>
	<label for="<?php echo $this->get_field_id('count'); ?>">顯示文章數量：</label>
	<input class="widefat" id="<?php echo $this->get_field_id('count'); ?>" name="<?php echo $this->get_field_name('count'); ?>" type="text" value="<?php echo $count; ?>" />
</p>
		<?php
	}
}
?>